import { defineComponent as N, inject as ie, computed as te, openBlock as C, createElementBlock as V, normalizeClass as B, renderSlot as j, ref as T, createElementVNode as P, unref as x, toDisplayString as U, Fragment as q, renderList as Q, withModifiers as W, createTextVNode as Z, normalizeStyle as ae, createCommentVNode as Y, withKeys as J, withDirectives as ue, isRef as ee, vModelText as se, nextTick as _, provide as ce, createBlock as pe, withCtx as ne, createVNode as fe, getCurrentInstance as ge } from "vue";
const re = Symbol("SELECTED_PROVIDE");
let he = { checkboxId: 0 };
const me = ["disabled"], ve = /* @__PURE__ */ N({
  __name: "CButton",
  props: {
    type: { default: "default" },
    disabled: { type: Boolean, default: !1 },
    selectable: { type: Boolean, default: !1 },
    modelValue: { type: Boolean, default: !1 },
    data: { default: void 0 }
  },
  emits: {
    click: (c) => !0,
    "update:model-value": (c) => !0,
    change: (c) => !0
  },
  setup(c, { emit: l }) {
    const a = c, t = l;
    let e = ie(re, null);
    const p = te(() => {
      if (e) {
        if (e.selectMode == "single")
          return e.value == a.data;
        if (e.selectMode == "multiple")
          return e.value.indexOf(a.data) != -1;
      } else
        return a.selectable ? a.modelValue : !1;
    });
    function v(w) {
      if (e && e.change(a.data, !p.value), !a.disabled && a.selectable) {
        const h = !p.value;
        t("update:model-value", h), t("change", h);
      }
      t("click", w);
    }
    return (w, h) => (C(), V("button", {
      class: B([
        "c-button-" + w.type + (w.disabled ? "-disabled" : ""),
        p.value ? "c-button-" + w.type + "-selected" : ""
      ]),
      disabled: w.disabled,
      onClick: v
    }, [
      j(w.$slots, "default")
    ], 10, me));
  }
}), De = ["id", "value", "disabled"], be = ["for"], Se = /* @__PURE__ */ N({
  __name: "CCheckBox",
  props: {
    disabled: { type: Boolean, default: !1 },
    modelValue: { type: Boolean, default: !1 },
    label: { default: "" }
  },
  emits: {
    "update:model-value": (c) => !0,
    change: (c) => !0
  },
  setup(c, { emit: l }) {
    let a = T("c-check-box-" + (++he.checkboxId).toString());
    const t = l;
    function e(p) {
      const v = p.target?.checked || !1;
      t("update:model-value", v), t("change", v);
    }
    return (p, v) => (C(), V("div", null, [
      P("input", {
        id: x(a),
        type: "checkbox",
        value: p.modelValue,
        disabled: p.disabled,
        class: B([
          "c-check-box" + (p.disabled ? "-disabled" : "")
        ]),
        onInput: e
      }, null, 42, De),
      P("label", { for: x(a) }, U(p.label), 9, be)
    ]));
  }
}), we = /* @__PURE__ */ N({
  __name: "CGroup",
  props: {
    orientation: { default: "landscape" }
  },
  setup(c) {
    return (l, a) => (C(), V("div", {
      class: B(["c-group-" + l.orientation])
    }, [
      j(l.$slots, "default")
    ], 2));
  }
});
class oe {
  winId = M.instance.winId;
  widgetId;
  widgetType;
  list = [];
}
class H {
  /**
   * 拖入的数据点
   */
  index;
  /**
   * 数据的parent对象，一般是Array
   */
  parent;
  /**
   * 窗口id
   */
  winId = M.instance.winId;
  /**
   * 组件id
   */
  widgetId;
  /**
   * 组件的类型
   */
  widgetType;
}
class M {
  static instance = new M();
  _winId = (/* @__PURE__ */ new Date()).getTime();
  /**
   * 当前窗口ID，表示数据来源的窗口。
   */
  get winId() {
    return this._winId;
  }
  _widgetId = 0;
  /**
   * 生成新的控件ID，用于标识数据来月的控件。
   */
  get widgetId() {
    return ++this._widgetId;
  }
  /**
   * 验证是否为DragData
   * @param data 
   */
  getDragData(l) {
    if (l[0] != "{")
      return null;
    try {
      let a = JSON.parse(l);
      if (a.winId != null && a.widgetId != null)
        return a;
    } catch {
      return null;
    }
    return null;
  }
  /**
   * 如果是当前窗口发起的拖拽，则保存当前的拖拽信息
   */
  currentDragData;
}
const ye = ["onClick", "draggable", "onDragstart", "onDragover", "onDragleave", "onDrop", "onDragend"], Ce = {
  key: 0,
  class: "c-list-input"
}, Ve = /* @__PURE__ */ N({
  __name: "CList",
  props: {
    dataSource: {},
    modelValue: {},
    bindKey: { default: "" },
    multiChoice: { type: Boolean, default: !1 },
    hideBorder: { type: Boolean, default: !1 },
    itemDraggable: { type: Boolean, default: !1 }
  },
  emits: {
    "update:model-value": (c) => !0,
    change: (c) => !0,
    submit: (c) => !0,
    itemdragstart: (c, l) => !0,
    itemdropallow: (c, l, a) => !0,
    itemdrop: (c, l, a) => !0
  },
  setup(c, { emit: l }) {
    const a = T(null), t = c;
    let e = T(!1), p = T(0), v = T(null), w = M.instance.widgetId;
    const h = l;
    function K(d, g, r) {
      if (t.multiChoice) {
        let u = null;
        if (d.shiftKey)
          if (v.value == null)
            u = [g], v.value = g;
          else {
            u = [];
            let s = !1, D = v.value, F = g;
            t.dataSource.indexOf(v.value) > t.dataSource.indexOf(g) && (D = g, F = v.value);
            for (let A = 0; A < t.dataSource.length; A++) {
              let n = t.dataSource[A];
              n == D ? s = !0 : n == F && (s = !1), (s || n == F) && u.push(n);
            }
          }
        else if (d.ctrlKey) {
          const s = t.modelValue;
          u = s.concat(), s.indexOf(g) == -1 ? (u.push(g), v.value = g) : (u.splice(u.indexOf(g), 1), v.value = null);
        } else
          u = [g], v.value = g;
        u != null && (h("update:model-value", u), h("change", u));
      } else
        h("update:model-value", g), h("change", g), f();
    }
    function E(d, g, r) {
      let u = new oe();
      u.widgetType = "c-list", u.widgetId = w;
      let s;
      if (t.multiChoice) {
        const D = t.modelValue;
        D == null || D.indexOf(g) == -1 ? (s = [g], h("update:model-value", s), h("change", s)) : s = D;
      } else
        t.modelValue != g ? (s = g, h("update:model-value", s), h("change", s)) : s = t.modelValue;
      if (t.multiChoice)
        for (let D of s)
          u.list.push({
            data: D,
            index: t.dataSource.indexOf(D),
            parent: t.dataSource
          });
      else
        u.list.push({
          data: s,
          index: r,
          parent: t.dataSource
        });
      h("itemdragstart", d, u), !d.defaultPrevented && d.dataTransfer && (d.dataTransfer.dropEffect = "move", d.dataTransfer.setData(
        "application/json",
        JSON.stringify(u)
      ), d.dataTransfer.setDragImage(d.target, 0, 0), M.instance.currentDragData = u);
    }
    function $(d, g, r) {
      let u = G(d, r), s = new H();
      s.widgetType = "c-list", s.widgetId = w, s.index = u.index, s.parent = t.dataSource, h(
        "itemdropallow",
        d,
        s,
        M.instance.currentDragData
      ), d.defaultPrevented && (p.value = u.top, e.value = !0);
    }
    function R(d, g, r) {
      e.value = !1;
    }
    function I(d, g, r) {
      e.value = !1;
      let u = G(d, r), s = new H();
      s.widgetType = "c-list", s.widgetId = w, s.index = u.index, s.parent = t.dataSource, h(
        "itemdrop",
        d,
        s,
        M.instance.currentDragData
      );
    }
    function z(d, g, r) {
      M.instance.currentDragData = void 0;
    }
    function G(d, g) {
      let r = d.currentTarget, u = r.getBoundingClientRect(), s = r.parentElement.getBoundingClientRect(), D = u.top - s.top + r.parentElement.scrollTop;
      return d.clientY > u.top + u.height / 2 ? { index: g + 1, top: D + u.height } : { index: g, top: D };
    }
    var o = "";
    function b(d) {
      if (!(d.ctrlKey || d.altKey || d.metaKey || d.shiftKey))
        if (d.code == "ArrowUp" || d.code == "ArrowDown") {
          if (t.modelValue == null) {
            const g = t.multiChoice ? [t.dataSource[0]] : t.dataSource[0];
            h("update:model-value", g), h("change", g), a.value.scrollTop = 0;
          } else {
            let g = null;
            t.multiChoice ? g = t.modelValue[0] : g = t.modelValue;
            let r = t.dataSource.indexOf(g), u = d.code == "ArrowUp" ? r - 1 : r + 1, s = t.dataSource[u];
            if (s) {
              const D = t.multiChoice ? [s] : s;
              h("update:model-value", D), h("change", D), a.value.children[u].scrollIntoView({
                block: "nearest"
                // behavior: "smooth"//不要动画效果更好
              });
            }
          }
          d.preventDefault();
        } else if (d.code >= "KeyA" && d.code <= "KeyZ" || d.code >= "Digit0" && d.code <= "Digit9" || d.code >= "Numpad0" && d.code <= "Numpad9") {
          let g = d.code.replace(/Key|Digit|Numpad/g, "");
          o += g, k();
        } else
          d.code == "Enter" ? o != "" ? k() : f() : d.code == "Backspace" && o != "" ? (o = o.substr(0, o.length - 1), o != "" && k()) : d.code == "Escape" && (o = "");
    }
    function f() {
      h("submit", t.modelValue);
    }
    function k() {
      let d = [], g = 0;
      t.multiChoice ? g = t.modelValue == null ? 0 : t.dataSource.indexOf(t.modelValue[0]) + 1 : g = t.modelValue == null ? 0 : t.dataSource.indexOf(t.modelValue) + 1, g >= a.value.children.length && (g = 0);
      for (let r = g; r < a.value.children.length; r++)
        d.push(a.value.children[r]);
      for (let r = 0; r < g; r++)
        d.push(a.value.children[r]);
      for (let r of d)
        if ((r.textContent || "").replace(/(?![A-Z|a-z|0-9])/g, "").toUpperCase().indexOf(o) != -1) {
          let s = t.dataSource[Array.prototype.indexOf.call(a.value.children, r)];
          const D = t.multiChoice ? [s] : s;
          h("update:model-value", D), h("change", D), r.scrollIntoView({ block: "nearest" });
          break;
        }
    }
    return (d, g) => (C(), V("div", {
      class: B(["c-list-out-box", { "c-list-no-border": d.hideBorder }]),
      tabindex: "0",
      onKeydown: b
    }, [
      P("div", {
        class: B(["c-list-in-box", { "c-list-no-border": d.hideBorder }]),
        ref_key: "list",
        ref: a
      }, [
        (C(!0), V(q, null, Q(d.dataSource, (r, u) => (C(), V("div", {
          key: d.bindKey == "" ? "k" + u : r[d.bindKey],
          class: B(["c-list-item", { "c-list-item-sel": d.multiChoice ? d.modelValue.indexOf(r) != -1 : d.modelValue == r }]),
          onClick: W((s) => K(s, r), ["left"]),
          draggable: d.itemDraggable,
          onDragstart: (s) => E(s, r, u),
          onDragover: (s) => $(s, r, u),
          onDragleave: (s) => R(),
          onDrop: (s) => I(s, r, u),
          onDragend: (s) => z()
        }, [
          j(d.$slots, "item", {
            item: r,
            index: u
          }, () => [
            Z(U(u + ":" + JSON.stringify(r)), 1)
          ])
        ], 42, ye))), 128)),
        x(e) ? (C(), V("div", {
          key: 0,
          class: "c-list-drop-view",
          style: ae({ top: x(p) + "px" })
        }, null, 4)) : Y("", !0)
      ], 2),
      x(o) != "" ? (C(), V("label", Ce, U(x(o)), 1)) : Y("", !0)
    ], 34));
  }
}), Ie = ["tabindex", "disabled"], xe = { class: "c-number-input-label" }, ke = { class: "c-number-input-value" }, Te = /* @__PURE__ */ N({
  __name: "CNumberInput",
  props: {
    label: { default: "" },
    modelValue: { default: 0 },
    disabled: { type: Boolean, default: !1 },
    minValue: {},
    maxValue: {},
    step: { default: 1 }
  },
  emits: {
    "update:model-value": (c) => !0,
    change: (c) => !0
  },
  setup(c, { emit: l }) {
    var a = "1234567890.-";
    let t = c, e = T(!1), p = T("");
    const v = T(null), w = T(null), h = l;
    function K(r) {
      return t.minValue != null && (r = Math.max(t.minValue, r)), t.maxValue != null && (r = Math.min(t.maxValue, r)), r;
    }
    function E(r, u) {
      let s = (F) => {
        r(F);
      }, D = (F) => {
        u(F), document.removeEventListener("mousemove", s), document.removeEventListener("mouseup", D);
      };
      document.addEventListener("mousemove", s), document.addEventListener("mouseup", D);
    }
    function $(r) {
      r();
      let u, s = setTimeout(() => {
        u = setInterval(() => {
          r();
        }, 10);
      }, 500), D = (F) => {
        clearInterval(u), clearTimeout(s), document.removeEventListener("mouseup", D);
      };
      document.addEventListener("mouseup", D);
    }
    function R(r) {
      if (t.disabled)
        return;
      let u = r.clientX, s = t.modelValue;
      E(
        (D) => {
          let A = (D.clientX - u) * 2 * t.step / 10, n = K(s + A), i = Math.floor(n / t.step) * t.step;
          h("update:model-value", i), h("change", i);
        },
        (D) => {
        }
      );
    }
    function I(r) {
      r.stopPropagation(), r.stopImmediatePropagation(), !t.disabled && $(() => {
        let u = K(t.modelValue - t.step);
        h("update:model-value", u), h("change", u);
      });
    }
    function z(r) {
      r.stopPropagation(), r.stopImmediatePropagation(), !t.disabled && $(() => {
        let u = K(t.modelValue + t.step);
        h("update:model-value", u), h("change", u);
      });
    }
    const G = te(() => t.maxValue != null && t.minValue != null ? (t.modelValue - t.minValue) / (t.maxValue - t.minValue) : 0);
    function o() {
      let r = K(t.modelValue - t.step);
      h("update:model-value", r), h("change", r);
    }
    function b() {
      let r = K(t.modelValue + t.step);
      h("update:model-value", r), h("change", r);
    }
    async function f() {
      e.value = !0, p.value = t.modelValue.toString(), await _(), w.value.focus();
    }
    async function k() {
      e.value != !1 && (e.value = !1, p.value = "", await _(), v.value.focus());
    }
    async function d() {
      e.value = !1;
      let r = parseFloat(p.value);
      (r == null || isNaN(r)) && (r = 0), r = K(r);
      let u = Math.floor(r / t.step) * t.step;
      h("update:model-value", u), h("change", u), p.value = "", await _(), v.value.focus();
    }
    async function g(r) {
      a.indexOf(r.key) != -1 && (e.value = !0, await _(), w.value.focus());
    }
    return (r, u) => x(e) ? ue((C(), V("input", {
      key: 1,
      ref_key: "editor",
      ref: w,
      type: "text",
      autocomplete: "off",
      "onUpdate:modelValue": u[0] || (u[0] = (s) => ee(p) ? p.value = s : p = s),
      class: "c-number-input",
      onKeydown: [
        J(k, ["esc"]),
        J(d, ["enter"])
      ],
      onBlur: k
    }, null, 544)), [
      [se, x(p)]
    ]) : (C(), V("div", {
      key: 0,
      ref_key: "view",
      ref: v,
      class: B([x(t).disabled ? "c-number-input-disabled" : "c-number-input"]),
      style: ae({ "--progress": G.value * 100 + "%" }),
      onMousedown: R,
      tabindex: x(t).disabled ? "" : 0,
      onKeydown: [
        J(o, ["left"]),
        J(b, ["right"]),
        J(f, ["enter"]),
        g
      ],
      disabled: x(t).disabled
    }, [
      P("label", {
        class: "c-number-input-left",
        onMousedown: I
      }, "◀", 32),
      P("label", xe, U(x(t).label) + ":", 1),
      P("label", ke, U(r.modelValue), 1),
      P("label", {
        class: "c-number-input-right",
        onMousedown: z
      }, "▶", 32)
    ], 46, Ie));
  }
}), Oe = /* @__PURE__ */ N({
  __name: "CSelectableGroup",
  props: {
    orientation: { default: "landscape" },
    selectMode: { default: "single" },
    modelValue: { default: void 0 }
  },
  emits: {
    "update:model-value": (c) => !0,
    change: (c) => !0
  },
  setup(c, { emit: l }) {
    const a = c, t = l;
    return ce(re, {
      change(e, p) {
        if (a.selectMode == "single")
          p && (t("update:model-value", e), t("change", e));
        else if (p) {
          if (!a.modelValue || a.modelValue.indexOf(e) == -1) {
            let v = a.modelValue ? a.modelValue.slice() : [];
            v.push(e), t("update:model-value", v), t("change", v);
          }
        } else {
          let v = a.modelValue ? a.modelValue.filter((w) => w != e) : [];
          t("update:model-value", v), t("change", v);
        }
      },
      get selectMode() {
        return a.selectMode;
      },
      get value() {
        return a.selectMode == "single" || a.modelValue ? a.modelValue : [];
      }
    }), (e, p) => (C(), V("div", {
      class: B(["c-group-" + e.orientation])
    }, [
      j(e.$slots, "default")
    ], 2));
  }
}), Be = ["placeholder", "disabled", "rows", "value"], Ke = /* @__PURE__ */ N({
  __name: "CTextArea",
  props: {
    placeholder: { default: void 0 },
    disabled: { type: Boolean, default: !1 },
    minRows: { default: 1 },
    maxRows: {},
    modelValue: { default: "" }
  },
  emits: {
    "update:model-value": (c) => !0,
    change: (c) => !0
  },
  setup(c, { emit: l }) {
    const a = c;
    let t = te(() => {
      let v = 0;
      for (let h of a.modelValue)
        h == `
` && v++;
      let w = Math.max(v, a.minRows);
      return a.maxRows && w > a.maxRows && (w = a.maxRows), w;
    });
    const e = l;
    function p(v) {
      const w = v.target?.value || "";
      e("update:model-value", w), e("change", w);
    }
    return (v, w) => (C(), V("textarea", {
      placeholder: v.placeholder,
      autocomplete: "off",
      disabled: v.disabled,
      rows: x(t),
      class: B([
        "c-text-area" + (v.disabled ? "-disabled" : "")
      ]),
      value: v.modelValue,
      onInput: p
    }, null, 42, Be));
  }
}), Ee = ["placeholder", "value", "disabled"], Me = /* @__PURE__ */ N({
  __name: "CTextInput",
  props: {
    placeholder: { default: void 0 },
    disabled: { type: Boolean, default: !1 },
    modelValue: { default: "" }
  },
  emits: {
    "update:model-value": (c) => !0,
    change: (c) => !0
  },
  setup(c, { emit: l }) {
    const a = l;
    function t(e) {
      const p = e.target?.value || "";
      a("update:model-value", p), a("change", p);
    }
    return (e, p) => (C(), V("input", {
      type: "text",
      placeholder: e.placeholder,
      autocomplete: "off",
      value: e.modelValue,
      disabled: e.disabled,
      class: B([
        "c-text-input" + (e.disabled ? "-disabled" : "")
      ]),
      onInput: t
    }, null, 42, Ee));
  }
});
class X {
  static bindKeyId = 0;
  /**
   * 唯一ID 方便vue渲染节点
   */
  bindKey = X.bindKeyId++;
  /**
   * 父节点
   */
  parent;
  /**
   * 子节点
   */
  children;
  /**
   * 允许拥有子节点
   */
  haveChildren;
  /**
   * 是否是已折叠的
   */
  isFolded = !0;
  /**
   * 所绑定的数据
   */
  data;
  /**
   * 获取下一项,无论节点是否打开
   */
  get next() {
    if (this.children && this.children.length > 0)
      return this.children[0];
    {
      let l, a = this;
      for (; l == null && a != null && a.parent != null; )
        l = a.parent.children[a.parent.children.indexOf(a) + 1], a = a.parent;
      return l;
    }
  }
  /**
   * 获取上一项,无论节点是否打开
   */
  get prev() {
    if (this.parent) {
      let l = this.parent.children[this.parent.children.indexOf(this) - 1];
      if (l) {
        for (; l.children; )
          l = l.children[l.children.length - 1];
        return l;
      } else
        return this.parent;
    }
  }
  /**
   * 获取下一项,节点必须打开才会进入子节点
   */
  get nextOpend() {
    if (!this.isFolded && this.children && this.children.length > 0)
      return this.children[0];
    {
      let l, a = this;
      for (; l == null && a != null && a.parent != null; )
        l = a.parent.children[a.parent.children.indexOf(a) + 1], a = a.parent;
      return l;
    }
  }
  /**
   * 获取上一项,节点必须打开才会进入子节点
   */
  get prevOpend() {
    if (this.parent) {
      let l = this.parent.children[this.parent.children.indexOf(this) - 1];
      if (l) {
        for (; !l.isFolded && l.children; )
          l = l.children[l.children.length - 1];
        return l;
      } else
        return this.parent;
    }
  }
  /**
   * 查找自己的索引全局索引
   */
  get index() {
    let l = this.prev, a = 0;
    for (; l != null; )
      a++, l = l.prev;
    return a;
  }
  /**
   * 向上打开所有节点
   */
  openToParent() {
    let l = this.parent;
    for (; l; )
      l.isFolded = !1, l = l.parent;
  }
  /**
   * 遍历节点，进行逻辑上的关闭操作 返回true则折叠，false则打开
   * @param logic 
   */
  fold(l) {
    if (this.isFolded = l(this.data), this.children)
      for (let a of this.children)
        a.fold(l);
  }
  /**
   * 将树打开到目标数据
   * @param data 
   */
  openTo(l) {
    let a = this.find(l);
    if (a) {
      let t = a;
      for (; t != null; )
        t.isFolded = !1, t = t.parent;
    }
    return a;
  }
  /**
   * 查找数据对应的树对象
   * @param data 
   */
  find(l) {
    if (this.data == l)
      return this;
    if (this.children) {
      for (let a of this.children) {
        let t = a.find(l);
        if (t)
          return t;
      }
      return;
    } else
      return;
  }
  /**
   * 获取共有几个父节点
   */
  get parentCount() {
    let l = this.parent, a = 0;
    for (; l; )
      a++, l = l.parent;
    return a;
  }
  /**
   * 将原始数据转换成数据源数据，方便tree组件解析
   */
  static toDataSource(l, a) {
    let t = new X();
    if (t.data = l, l[a]) {
      t.children = [], t.haveChildren = !0;
      for (let e of l[a]) {
        let p = this.toDataSource(e, a);
        p.parent = t, t.children.push(p);
      }
    }
    return t;
  }
}
const $e = ["draggable"], Fe = {
  key: 0,
  class: "tree-item-icon fa fa-file-o"
}, Le = { key: 0 }, de = /* @__PURE__ */ N({
  __name: "CTreeNode",
  props: {
    dataSource: {},
    modelValue: {},
    multiChoice: { type: Boolean, default: !1 },
    gap: { default: 0 },
    currentSelected: {},
    itemDraggable: { type: Boolean },
    widgetId: {}
  },
  emits: {
    change: (c) => !0,
    changeSel: (c) => !0,
    dragstart: (c, l, a) => !0,
    dragover: (c, l, a) => !0,
    dragleave: (c, l, a) => !0,
    drop: (c, l, a) => !0,
    dragend: (c, l, a) => !0,
    doubleClickItem: (c, l) => !0
  },
  setup(c, { expose: l, emit: a }) {
    const t = T([]), e = c, p = a;
    function v(o) {
      if (e.multiChoice) {
        let b = e.modelValue, f = null;
        if (o.shiftKey)
          if (e.currentSelected == null)
            f = [e.dataSource], p("changeSel", e.dataSource);
          else {
            f = [];
            let k = e.currentSelected, d = e.dataSource;
            for (k.index > d.index && (k = e.dataSource, d = e.currentSelected), f.push(k); k != null && k.next != d; )
              k = k.next, k && f.push(k);
            f.push(d);
          }
        else
          o.ctrlKey ? (f = b.concat(), b.indexOf(e.dataSource) == -1 ? (f.push(e.dataSource), p("changeSel", e.dataSource)) : (f.splice(f.indexOf(e.dataSource), 1), p("changeSel", null))) : (f = [e.dataSource], p("changeSel", e.dataSource));
        f != null && p("change", f);
      } else
        e.dataSource != e.modelValue && p("change", e.dataSource);
    }
    function w(o, b, f) {
      p(
        "dragstart",
        o,
        b || e.dataSource,
        f ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function h(o, b, f) {
      p(
        "dragover",
        o,
        b || e.dataSource,
        f ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function K(o, b, f) {
      p(
        "dragleave",
        o,
        b || e.dataSource,
        f ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function E(o, b, f) {
      p(
        "drop",
        o,
        b || e.dataSource,
        f ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function $(o, b, f) {
      p(
        "dragend",
        o,
        b || e.dataSource,
        f ?? (e.dataSource.parent ? e.dataSource.parent.children.indexOf(e.dataSource) : null)
      );
    }
    function R(o) {
      p("doubleClickItem", o, e.dataSource), o.defaultPrevented || (e.dataSource.isFolded = !e.dataSource.isFolded);
    }
    function I(o) {
      p("change", o);
    }
    function z(o) {
      p("changeSel", o);
    }
    function G(o, b) {
      p("doubleClickItem", o, e.dataSource);
    }
    return l({ childRefs: t }), (o, b) => (C(), V("div", null, [
      P("div", {
        class: B(["c-tree-item", { "c-tree-item-sel": o.multiChoice ? o.modelValue.indexOf(o.dataSource) != -1 : o.modelValue == o.dataSource }]),
        draggable: o.itemDraggable,
        onClick: b[1] || (b[1] = W((f) => v(f), ["left"])),
        onDblclick: b[2] || (b[2] = W((f) => R(f), ["left"])),
        onDragstart: b[3] || (b[3] = (f) => w(f)),
        onDragover: b[4] || (b[4] = (f) => h(f)),
        onDragleave: b[5] || (b[5] = (f) => K(f)),
        onDrop: b[6] || (b[6] = (f) => E(f)),
        onDragend: b[7] || (b[7] = (f) => $(f))
      }, [
        (C(!0), V(q, null, Q(o.gap, (f) => (C(), V("div", {
          key: f,
          class: "c-tree-gap gap-line"
        }))), 128)),
        o.dataSource.children != null && o.dataSource.children.length > 0 ? (C(), V("i", {
          key: 0,
          class: B(["tree-fold-icon fa", { "fa-chevron-down": !o.dataSource.isFolded, "fa-chevron-right": o.dataSource.isFolded }]),
          "aria-hidden": "true",
          onClick: b[0] || (b[0] = (f) => o.dataSource.isFolded = !o.dataSource.isFolded)
        }, null, 2)) : Y("", !0),
        P("div", {
          class: B(["c-tree-item-content", ["tree-node-id-" + o.dataSource.bindKey]])
        }, [
          j(o.$slots, "icon", { tree: o.dataSource }, () => [
            o.dataSource.children == null ? (C(), V("i", Fe)) : Y("", !0)
          ]),
          j(o.$slots, "item", { tree: o.dataSource }, () => [
            Z(U(o.dataSource.bindKey), 1)
          ])
        ], 2)
      ], 42, $e),
      o.dataSource.children != null && o.dataSource.children.length > 0 && !o.dataSource.isFolded ? (C(), V("div", Le, [
        (C(!0), V(q, null, Q(o.dataSource.children, (f) => (C(), pe(de, {
          ref_for: !0,
          ref_key: "childRefs",
          ref: t,
          key: f.bindKey,
          dataSource: f,
          multiChoice: o.multiChoice,
          gap: o.gap + 1,
          modelValue: o.modelValue,
          currentSelected: o.currentSelected,
          widgetId: o.widgetId,
          itemDraggable: o.itemDraggable,
          onChange: I,
          onChangeSel: z,
          onDoubleClickItem: G,
          onDragstart: w,
          onDragover: h,
          onDragleave: K,
          onDrop: E,
          onDragend: $
        }, {
          item: ne((k) => [
            j(o.$slots, "item", {
              tree: k.tree
            }, () => [
              Z(U(k.tree.bindKey), 1)
            ])
          ]),
          _: 2
        }, 1032, ["dataSource", "multiChoice", "gap", "modelValue", "currentSelected", "widgetId", "itemDraggable"]))), 128))
      ])) : Y("", !0)
    ]));
  }
}), Re = {
  key: 0,
  class: "c-list-input"
}, Pe = /* @__PURE__ */ N({
  __name: "CTree",
  props: {
    dataSource: {},
    modelValue: {},
    multiChoice: { type: Boolean, default: !1 },
    itemDraggable: { type: Boolean, default: !1 },
    hideBorder: { type: Boolean, default: !1 }
  },
  emits: {
    "update:model-value": (c) => !0,
    change: (c) => !0,
    changeSel: (c) => !0,
    itemdragstart: (c, l) => !0,
    itemdropallow: (c, l, a) => !0,
    itemdrop: (c, l, a) => !0,
    drop: (c, l, a) => !0,
    dragend: (c, l, a) => !0,
    doubleClickItem: (c, l) => !0
  },
  setup(c, { expose: l, emit: a }) {
    const t = T(null), e = c;
    let p = T(!1), v = T(0), w = T(0), h = T(3), K = T(null), E = T(!1), $ = T(M.instance.widgetId);
    const R = T(null), I = a;
    function z(n) {
      I("update:model-value", n), I("change", n);
    }
    function G(n) {
      K.value = n;
    }
    function o(n, i) {
      I("doubleClickItem", n, e.dataSource);
    }
    function b(n, i) {
      if (n.dataSource == i)
        return n.$el;
      for (let S of n.childRefs) {
        let y = b(S, i);
        if (y)
          return y;
      }
    }
    async function f(n) {
      let i = n;
      for (; i != null; )
        i.isFolded = !1, i = i.parent;
      await _();
      let S = t.value?.childRefs[0], y = b(S, n);
      y && (R.value.scrollTop = y.offsetTop);
    }
    function k(n, i, S) {
      let y = new oe();
      y.widgetType = "c-tree", y.widgetId = $.value;
      let m;
      if (e.multiChoice ? e.modelValue == null || e.modelValue.indexOf(i) == -1 ? (m = [i], I("update:model-value", m), I("change", m)) : m = e.modelValue : e.modelValue != i ? (m = i, I("update:model-value", m), I("change", m)) : m = e.modelValue, e.multiChoice)
        for (let O of m)
          y.list.push({
            data: O,
            index: O.parent ? O.parent.children.indexOf(O) : -1,
            parent: O.parent
          });
      else
        y.list.push({
          data: m,
          index: S,
          parent: m.parent
        });
      I("itemdragstart", n, y), !n.defaultPrevented && n.dataTransfer && (n.dataTransfer.dropEffect = "move", n.dataTransfer.setData(
        "application/json",
        JSON.stringify(y, (O, L) => O == "parent" && L instanceof X ? null : L)
      ), n.dataTransfer.setDragImage(n.target, 0, 0), M.instance.currentDragData = y);
    }
    function d(n, i, S) {
      let y = s(n, i, S), m = new H();
      m.widgetType = "c-tree", m.widgetId = $.value, m.index = y.index, m.parent = e.dataSource, I(
        "itemdropallow",
        n,
        m,
        M.instance.currentDragData
      ), n.defaultPrevented && (v.value = y.top, p.value = !0, h.value = y.height, w.value = y.gap);
    }
    function g(n, i) {
      p.value = !1;
    }
    function r(n, i, S) {
      p.value = !1;
      let y = s(n, i, S), m = new H();
      m.widgetType = "c-tree", m.widgetId = $.value, m.index = y.index, m.parent = y.target;
      let O = M.instance.currentDragData;
      if (O)
        for (let L = 0; L < O.list.length; L++)
          O.list[L].data == m.parent && (O.list.splice(L, 1), L--);
      I("itemdrop", n, m, O);
    }
    function u() {
      M.instance.currentDragData = void 0;
    }
    function s(n, i, S) {
      let m = n.currentTarget.getBoundingClientRect(), O = R.value.getBoundingClientRect(), L = m.top - O.top + R.value.scrollTop;
      return (i.haveChildren ? n.clientY > m.top + m.height / 4 * 3 : n.clientY >= m.top + m.height / 2) ? {
        index: !i.isFolded && i.haveChildren ? 0 : S + 1,
        //已经关闭说明是向下插入
        target: !i.isFolded && i.haveChildren ? i : i.parent ? i.parent : void 0,
        //如果自己没用parent则不操作
        top: L + m.height,
        height: 3,
        isPutIn: !1,
        gap: ((!i.isFolded && i.haveChildren ? 1 : 0) + i.parentCount) * 11
        //已经打开则只能插入在子集
      } : (i.haveChildren ? n.clientY < m.top + m.height / 4 : n.clientY < m.top + m.height / 2) ? {
        index: i.parent ? S : 0,
        target: i.parent ? i.parent : i,
        top: L,
        height: 3,
        isPutIn: !1,
        gap: i.parentCount * 11
      } : {
        index: i.children ? i.children.length : 0,
        target: i,
        top: L,
        height: m.height,
        isPutIn: !0,
        gap: 0
      };
    }
    let D = "";
    async function F(n) {
      let i = R.value;
      if (n.code == "ArrowUp" || n.code == "ArrowDown") {
        if (e.modelValue == null) {
          const S = e.multiChoice ? [e.dataSource] : e.dataSource;
          I("update:model-value", S), I("change", S), i.scrollTop = 0;
        } else {
          let S;
          e.multiChoice ? S = e.modelValue[0] : S = e.modelValue;
          let y = n.code == "ArrowUp" ? S.prevOpend : S.nextOpend;
          if (y) {
            const O = e.multiChoice ? [y] : y;
            I("update:model-value", O), I("change", O), y.openToParent();
          }
          await _();
          let m = i.querySelector(".c-tree-item-sel");
          m && m.scrollIntoView({
            block: "nearest"
            // behavior: "smooth"//不要动画效果更好
          });
        }
        n.preventDefault();
      } else if (n.code == "ArrowLeft" || n.code == "ArrowRight") {
        let S;
        e.multiChoice ? S = e.modelValue[0] : S = e.modelValue, S && (S.isFolded = n.code == "ArrowLeft"), n.preventDefault();
      } else if (n.code >= "KeyA" && n.code <= "KeyZ" || n.code >= "Digit0" && n.code <= "Digit9" || n.code >= "Numpad0" && n.code <= "Numpad9") {
        let S = n.code.replace(/Key|Digit|Numpad/g, "");
        console.log(S), D += S, A();
      } else
        n.code == "Enter" && D != "" ? A() : n.code == "Backspace" && D != "" ? (D = D.substr(0, D.length - 1), D != "" && A()) : n.code == "Escape" && (D = "");
    }
    async function A() {
      let n;
      e.multiChoice ? e.modelValue == null || e.modelValue.length == 0 ? n = e.dataSource : n = e.modelValue[0] : e.modelValue == null ? n = e.dataSource : n = e.modelValue, n.openToParent(), await _(), n.haveChildren && n.isFolded && (n.isFolded = !1, await _());
      let i = n.next;
      for (; i != n; ) {
        i == null && (i = e.dataSource);
        let S = ge()?.proxy?.$el.querySelector(".tree-node-id-" + i.bindKey);
        if ((S.textContent || "").replace(/(?![A-Z|a-z|0-9])/g, "").toUpperCase().indexOf(D) != -1) {
          const m = e.multiChoice ? [i] : i;
          I("update:model-value", m), I("change", m), S.scrollIntoView({ block: "nearest" });
          break;
        }
        i.haveChildren && i.isFolded && (i.isFolded = !1, await _()), i = i.next;
      }
    }
    return l({ scrollTo: f }), (n, i) => (C(), V("div", {
      class: B(["c-list-out-box", { "c-tree-show-line": x(E), "c-list-no-border": n.hideBorder }]),
      onMouseover: i[0] || (i[0] = (S) => ee(E) ? E.value = !0 : E = !0),
      onMouseleave: i[1] || (i[1] = (S) => ee(E) ? E.value = !1 : E = !1),
      tabindex: "0",
      onKeydown: F
    }, [
      P("div", {
        class: B(["c-list-in-box", { "c-list-no-border": n.hideBorder }]),
        ref_key: "inbox",
        ref: R
      }, [
        fe(de, {
          ref_key: "treeRef",
          ref: t,
          dataSource: n.dataSource,
          multiChoice: n.multiChoice,
          modelValue: n.modelValue,
          currentSelected: x(K),
          widgetId: x($),
          itemDraggable: n.itemDraggable,
          onChange: z,
          onChangeSel: G,
          onDoubleClickItem: o,
          onDragstart: k,
          onDragover: d,
          onDragleave: g,
          onDrop: r,
          onDragend: u,
          class: "c-tree-node"
        }, {
          item: ne(({ tree: S }) => [
            j(n.$slots, "item", { tree: S }, () => [
              Z(U(S.bindKey), 1)
            ])
          ]),
          _: 3
        }, 8, ["dataSource", "multiChoice", "modelValue", "currentSelected", "widgetId", "itemDraggable"]),
        x(p) ? (C(), V("div", {
          key: 0,
          class: "c-tree-drop-view",
          style: ae({ top: x(v) + "px", "--gap-width": x(w), height: x(h) + "px" })
        }, null, 4)) : Y("", !0)
      ], 2),
      x(D) != "" ? (C(), V("label", Re, U(x(D)), 1)) : Y("", !0)
    ], 34));
  }
}), le = { CButton: ve, CCheckBox: Se, CGroup: we, CList: Ve, CNumberInput: Te, CSelectableGroup: Oe, CTextArea: Ke, CTextInput: Me, CTree: Pe }, Ae = (c) => {
  for (let l in le)
    c.component(l, le[l]);
};
export {
  ve as CButton,
  Se as CCheckBox,
  we as CGroup,
  Ve as CList,
  Te as CNumberInput,
  Oe as CSelectableGroup,
  Ke as CTextArea,
  Me as CTextInput,
  Pe as CTree,
  X as TreeNodeData,
  Ae as install
};
//# sourceMappingURL=compactui2.es.js.map
